"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var ReactiveState_1 = require('./ReactiveState');
var ReactiveEvent_1 = require('./ReactiveEvent');
var ReactiveProperty_1 = require('./ReactiveProperty');
var ReactiveObject = (function (_super) {
    __extends(ReactiveObject, _super);
    function ReactiveObject(errorScheduler) {
        _super.call(this, errorScheduler);
        this.properties = [];
    }
    ReactiveObject.prototype.getPropertyName = function (prop) {
        if (prop.name == null) {
            this.resolvePropertyNames();
        }
        return prop.name;
    };
    ReactiveObject.prototype.resolvePropertyNames = function () {
        var _this = this;
        Object
            .getOwnPropertyNames(this)
            .map(function (name) { return ({ name: name, prop: _this[name] }); })
            .filter(function (x) { return x.prop != null && x.prop.owner === _this && x.prop.name == null; })
            .forEach(function (x) {
            x.prop.name = x.name;
        });
    };
    ReactiveObject.prototype.registerProperty = function (prop) {
        var _this = this;
        this.add(prop.changing
            .subscribe(function (x) {
            _this.notifyPropertyChanging(function () { return new ReactiveEvent_1.ReactiveEvent(_this, {
                property: x.source,
                propertyName: _this.getPropertyName(x.source),
            }); });
        }, this.thrownErrorsHandler.next));
        this.add(prop.changed
            .subscribe(function (x) {
            _this.notifyPropertyChanged(function () { return new ReactiveEvent_1.ReactiveEvent(_this, {
                property: x.source,
                propertyName: _this.getPropertyName(x.source),
            }); });
        }, this.thrownErrorsHandler.next));
        this.properties.push(prop);
    };
    ReactiveObject.prototype.propertyFrom = function (source, initialValue, errorScheduler) {
        var prop = new ReactiveProperty_1.ReactiveStreamProperty(source, this, initialValue, errorScheduler);
        this.registerProperty(prop);
        return prop;
    };
    ReactiveObject.prototype.property = function (initialValue) {
        var prop = new ReactiveProperty_1.ReactiveValueProperty(this, initialValue);
        this.registerProperty(prop);
        return prop;
    };
    return ReactiveObject;
}(ReactiveState_1.ReactiveState));
exports.ReactiveObject = ReactiveObject;
