"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var rxjs_1 = require('rxjs');
var SubjectScheduler_1 = require('./SubjectScheduler');
var ReactiveEvent_1 = require('./ReactiveEvent');
var ReactiveState_1 = require('./ReactiveState');
var ReactiveProperty = (function (_super) {
    __extends(ReactiveProperty, _super);
    function ReactiveProperty(owner, initialValue, errorScheduler) {
        _super.call(this, errorScheduler);
        this.owner = owner;
        this.currentValue = initialValue;
    }
    ReactiveProperty.prototype.initialize = function (source) {
        var _this = this;
        this.add(source
            .distinctUntilChanged()
            .subscribe(function (x) {
            _this.notifyPropertyChanging(function () { return new ReactiveEvent_1.ReactiveEvent(_this, x); });
            _this.currentValue = x;
            _this.notifyPropertyChanged(function () { return new ReactiveEvent_1.ReactiveEvent(_this, _this.currentValue); });
        }, this.thrownErrorsHandler.next));
    };
    Object.defineProperty(ReactiveProperty.prototype, "name", {
        get: function () {
            return this.propertyName;
        },
        set: function (propertyName) {
            if (this.propertyName != null) {
                throw 'Manually setting a reactive property name is not allowed';
            }
            this.propertyName = propertyName;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReactiveProperty.prototype, "value", {
        get: function () {
            return this.currentValue;
        },
        enumerable: true,
        configurable: true
    });
    return ReactiveProperty;
}(ReactiveState_1.ReactiveState));
exports.ReactiveProperty = ReactiveProperty;
var ReactiveStreamProperty = (function (_super) {
    __extends(ReactiveStreamProperty, _super);
    function ReactiveStreamProperty(source, owner, initialValue, errorScheduler) {
        _super.call(this, owner, initialValue, errorScheduler);
        this.source = source;
        this.initialize(source);
    }
    return ReactiveStreamProperty;
}(ReactiveProperty));
exports.ReactiveStreamProperty = ReactiveStreamProperty;
var ReactiveValueProperty = (function (_super) {
    __extends(ReactiveValueProperty, _super);
    function ReactiveValueProperty(owner, initialValue, scheduler, errorScheduler) {
        if (scheduler === void 0) { scheduler = rxjs_1.Scheduler.queue; }
        _super.call(this, owner, initialValue, errorScheduler);
        this.valueHandler = new SubjectScheduler_1.SubjectScheduler(scheduler);
        this.add(this.valueHandler);
        this.initialize(this.valueHandler.getScheduledObservable());
    }
    Object.defineProperty(ReactiveValueProperty.prototype, "source", {
        get: function () {
            return this.valueHandler.getScheduledObservable();
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(ReactiveValueProperty.prototype, "value", {
        get: function () {
            return this.currentValue;
        },
        set: function (value) {
            this.valueHandler.next(value);
        },
        enumerable: true,
        configurable: true
    });
    return ReactiveValueProperty;
}(ReactiveProperty));
exports.ReactiveValueProperty = ReactiveValueProperty;
